<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

class ChartsModelCharts extends JModel 
{
	var $_cacheDir = 'components/com_charts/cache';
	var $_path_to_xml = 'http://www.myhitparade.de/export/xml';
	var $_types = array('webradio','user','discjockey');
	var $_type = null;
	var $_week = null;
	var $_year = null;

	function __construct($options)
	{
		parent::__construct($options);
	}

	function getWeek()
	{
		if(empty($this->_week))
		{
			$this->getDate();
		}
		return $this->_week;
	}
	
	function getYear()
	{
		if(empty($this->_year))
		{
			$this->getDate();
		}
		return $this->_year;	
	}

	function getDate()
	{
		$db = JFactory::getDBO();
		if(date('w') == 0)
		{
			$sql = 'SELECT DATE_FORMAT(DATE_ADD(NOW(),INTERVAL 1 DAY),\'%v\') as `week`, DATE_FORMAT(DATE_ADD(NOW(),INTERVAL 1 DAY),\'%x\') as `year`';
		}
		else
		{
			$sql = 'SELECT DATE_FORMAT(NOW(),\'%v\') as `week`, DATE_FORMAT(NOW(),\'%x\') as `year`';
		}
		$db->setQuery($sql);

		$date = $db->loadAssoc();

		if($date)
		{
			$this->_week = $date['week'];
			$this->_year = $date['year'];
		}
		else
		{
			$this->_week = 1;
			$this->_year = 1970;
		}
	}

	function getType()
	{
		if(empty($this->_type))
		{
			$type = JRequest::getVar('type','webradio');
			if(!in_array($type,$this->_types))
			{
				$type = 'webradio';
			}
			$this->_type = $type;
		}
		return $this->_type;
	}

	function getData()
	{
		$type = $this->getType();

		if(!file_exists($this->_cacheDir.'/'.$type.'.xml') OR filemtime($this->_cacheDir.'/'.$type.'.xml') <= time()-900)
		{
			$xml = simplexml_load_file($this->_path_to_xml.'/'.$type);
			
			if(empty($xml->items) OR !$xml)
			{
				return array();
			}
			else
			{
				$cache = file_put_contents($this->_cacheDir.'/'.$type.'.xml',$xml->asXML());
				return $xml;
			}
		}
		else
		{
			$xml = @simplexml_load_file($this->_cacheDir.'/'.$type.'.xml');

			if(empty($xml->items) OR !$xml)
			{
				return array();
			}
			else
			{
				return $xml;
			}
		}
	}
}